page_type: reference
description: APIs for the model spec of TFLite Model Maker.

<link rel="stylesheet" href="/site-assets/css/style.css">

<!-- DO NOT EDIT! Automatically generated file. -->


<div itemscope itemtype="http://developers.google.com/ReferenceObject">
<meta itemprop="name" content="tflite_model_maker.model_spec" />
<meta itemprop="path" content="Stable" />
<meta itemprop="property" content="AUDIO_CLASSIFICATION_MODELS"/>
<meta itemprop="property" content="IMAGE_CLASSIFICATION_MODELS"/>
<meta itemprop="property" content="OBJECT_DETECTION_MODELS"/>
<meta itemprop="property" content="QUESTION_ANSWER_MODELS"/>
<meta itemprop="property" content="RECOMMENDATION_MODELS"/>
<meta itemprop="property" content="TEXT_CLASSIFICATION_MODELS"/>
</div>

# Module: tflite_model_maker.model_spec

<!-- Insert buttons and diff -->

<table class="tfo-notebook-buttons tfo-api nocontent" align="left">
<td>
  <a target="_blank" href="https://github.com/tensorflow/examples/blob/tflmm/v0.4.2/tensorflow_examples/lite/model_maker/public/model_spec/__init__.py">
    <img src="https://www.tensorflow.org/images/GitHub-Mark-32px.png" />
    View source on GitHub
  </a>
</td>
</table>



APIs for the model spec of TFLite Model Maker.



## Functions

[`get(...)`](../tflite_model_maker/model_spec/get): Gets model spec by name or instance, and init with args and kwarges.



<!-- Tabular view -->
 <table class="responsive fixed orange">
<colgroup><col width="214px"><col></colgroup>
<tr><th colspan="2"><h2 class="add-link">Other Members</h2></th></tr>

<tr>
<td>
AUDIO_CLASSIFICATION_MODELS<a id="AUDIO_CLASSIFICATION_MODELS"></a>
</td>
<td>
`['audio_browser_fft', 'audio_teachable_machine', 'audio_yamnet']`
</td>
</tr><tr>
<td>
IMAGE_CLASSIFICATION_MODELS<a id="IMAGE_CLASSIFICATION_MODELS"></a>
</td>
<td>
`['efficientnet_lite0',
 'efficientnet_lite1',
 'efficientnet_lite2',
 'efficientnet_lite3',
 'efficientnet_lite4',
 'mobilenet_v2',
 'resnet_50']`
</td>
</tr><tr>
<td>
OBJECT_DETECTION_MODELS<a id="OBJECT_DETECTION_MODELS"></a>
</td>
<td>
`['efficientdet_lite0',
 'efficientdet_lite1',
 'efficientdet_lite2',
 'efficientdet_lite3',
 'efficientdet_lite4']`
</td>
</tr><tr>
<td>
QUESTION_ANSWER_MODELS<a id="QUESTION_ANSWER_MODELS"></a>
</td>
<td>
`['bert_qa', 'mobilebert_qa', 'mobilebert_qa_squad']`
</td>
</tr><tr>
<td>
RECOMMENDATION_MODELS<a id="RECOMMENDATION_MODELS"></a>
</td>
<td>
`['recommendation']`
</td>
</tr><tr>
<td>
TEXT_CLASSIFICATION_MODELS<a id="TEXT_CLASSIFICATION_MODELS"></a>
</td>
<td>
`['bert_classifier', 'average_word_vec', 'mobilebert_classifier']`
</td>
</tr>
</table>
