page_type: reference
description: APIs to train an on-device recommendation model.

<link rel="stylesheet" href="/site-assets/css/style.css">

<!-- DO NOT EDIT! Automatically generated file. -->


<div itemscope itemtype="http://developers.google.com/ReferenceObject">
<meta itemprop="name" content="tflite_model_maker.recommendation" />
<meta itemprop="path" content="Stable" />
</div>

# Module: tflite_model_maker.recommendation

<!-- Insert buttons and diff -->

<table class="tfo-notebook-buttons tfo-api nocontent" align="left">
<td>
  <a target="_blank" href="https://github.com/tensorflow/examples/blob/tflmm/v0.4.2/tensorflow_examples/lite/model_maker/public/recommendation/__init__.py">
    <img src="https://www.tensorflow.org/images/GitHub-Mark-32px.png" />
    View source on GitHub
  </a>
</td>
</table>



APIs to train an on-device recommendation model.



#### Demo code:


<a href="https://github.com/tensorflow/examples/blob/master/tensorflow_examples/lite/model_maker/demo/recommendation_demo.py">https://github.com/tensorflow/examples/blob/master/tensorflow_examples/lite/model_maker/demo/recommendation_demo.py</a>

## Modules

[`spec`](../tflite_model_maker/recommendation/spec) module: APIs for recommendation specifications.

## Classes

[`class DataLoader`](../tflite_model_maker/recommendation/DataLoader): Recommendation data loader.

[`class ModelSpec`](../tflite_model_maker/recommendation/ModelSpec): Recommendation model spec.

[`class Recommendation`](../tflite_model_maker/recommendation/Recommendation): Recommendation task class.

## Functions

[`create(...)`](../tflite_model_maker/recommendation/create): Loads data and train the model for recommendation.
