page_type: reference
description: Class to hold parameters for model architecture configuration.

<link rel="stylesheet" href="/site-assets/css/style.css">

<!-- DO NOT EDIT! Automatically generated file. -->


<div itemscope itemtype="http://developers.google.com/ReferenceObject">
<meta itemprop="name" content="tflite_model_maker.recommendation.spec.ModelHParams" />
<meta itemprop="path" content="Stable" />
<meta itemprop="property" content="__eq__"/>
<meta itemprop="property" content="__ge__"/>
<meta itemprop="property" content="__gt__"/>
<meta itemprop="property" content="__init__"/>
<meta itemprop="property" content="__le__"/>
<meta itemprop="property" content="__lt__"/>
<meta itemprop="property" content="__ne__"/>
</div>

# tflite_model_maker.recommendation.spec.ModelHParams

<!-- Insert buttons and diff -->

<table class="tfo-notebook-buttons tfo-api nocontent" align="left">
<td>
  <a target="_blank" href="https://github.com/tensorflow/examples/blob/master/tensorflow_examples/lite/model_maker/third_party/recommendation/ml/configs/model_config.py#L19-L37">
    <img src="https://www.tensorflow.org/images/GitHub-Mark-32px.png" />
    View source on GitHub
  </a>
</td>
</table>



Class to hold parameters for model architecture configuration.

<pre class="devsite-click-to-copy prettyprint lang-py tfo-signature-link">
<code>tflite_model_maker.recommendation.spec.ModelHParams(
    hidden_layer_dims,
    eval_top_k,
    conv_num_filter_ratios,
    conv_kernel_size,
    lstm_num_units,
    num_predictions=attr_dict[&#x27;num_predictions&#x27;].default
)
</code></pre>



<!-- Placeholder for "Used in" -->




<!-- Tabular view -->
 <table class="responsive fixed orange">
<colgroup><col width="214px"><col></colgroup>
<tr><th colspan="2"><h2 class="add-link">Attributes</h2></th></tr>

<tr>
<td>
`hidden_layer_dims`<a id="hidden_layer_dims"></a>
</td>
<td>
List of hidden layer dimensions.
</td>
</tr><tr>
<td>
`eval_top_k`<a id="eval_top_k"></a>
</td>
<td>
Top k to evaluate.
</td>
</tr><tr>
<td>
`conv_num_filter_ratios`<a id="conv_num_filter_ratios"></a>
</td>
<td>
Number of filter ratios for the Conv1D layer.
</td>
</tr><tr>
<td>
`conv_kernel_size`<a id="conv_kernel_size"></a>
</td>
<td>
Size of the Conv1D layer kernel size.
</td>
</tr><tr>
<td>
`lstm_num_units`<a id="lstm_num_units"></a>
</td>
<td>
Number of units for the LSTM layer.
</td>
</tr><tr>
<td>
`num_predictions`<a id="num_predictions"></a>
</td>
<td>
Number of predictions to return with serving mode, which
has default value 10.
</td>
</tr>
</table>



## Methods

<h3 id="__eq__"><code>__eq__</code></h3>

<pre class="devsite-click-to-copy prettyprint lang-py tfo-signature-link">
<code>__eq__(
    other
)
</code></pre>

Method generated by attrs for class ModelConfig.


<h3 id="__ge__"><code>__ge__</code></h3>

<pre class="devsite-click-to-copy prettyprint lang-py tfo-signature-link">
<code>__ge__(
    other
)
</code></pre>

Method generated by attrs for class ModelConfig.


<h3 id="__gt__"><code>__gt__</code></h3>

<pre class="devsite-click-to-copy prettyprint lang-py tfo-signature-link">
<code>__gt__(
    other
)
</code></pre>

Method generated by attrs for class ModelConfig.


<h3 id="__le__"><code>__le__</code></h3>

<pre class="devsite-click-to-copy prettyprint lang-py tfo-signature-link">
<code>__le__(
    other
)
</code></pre>

Method generated by attrs for class ModelConfig.


<h3 id="__lt__"><code>__lt__</code></h3>

<pre class="devsite-click-to-copy prettyprint lang-py tfo-signature-link">
<code>__lt__(
    other
)
</code></pre>

Method generated by attrs for class ModelConfig.


<h3 id="__ne__"><code>__ne__</code></h3>

<pre class="devsite-click-to-copy prettyprint lang-py tfo-signature-link">
<code>__ne__(
    other
)
</code></pre>

Method generated by attrs for class ModelConfig.
