page_type: reference
description: APIs to create the searcher model.

<link rel="stylesheet" href="/site-assets/css/style.css">

<!-- DO NOT EDIT! Automatically generated file. -->


<div itemscope itemtype="http://developers.google.com/ReferenceObject">
<meta itemprop="name" content="tflite_model_maker.searcher" />
<meta itemprop="path" content="Stable" />
</div>

# Module: tflite_model_maker.searcher

<!-- Insert buttons and diff -->

<table class="tfo-notebook-buttons tfo-api nocontent" align="left">
<td>
  <a target="_blank" href="https://github.com/tensorflow/examples/blob/tflmm/v0.4.2/tensorflow_examples/lite/model_maker/public/searcher/__init__.py">
    <img src="https://www.tensorflow.org/images/GitHub-Mark-32px.png" />
    View source on GitHub
  </a>
</td>
</table>



APIs to create the searcher model.



#### Task guide:


<a href="https://www.tensorflow.org/lite/tutorials/model_maker_text_searcher">https://www.tensorflow.org/lite/tutorials/model_maker_text_searcher</a>

## Classes

[`class DataLoader`](../tflite_model_maker/searcher/DataLoader): Base DataLoader class for Searcher task.

[`class ExportFormat`](../tflite_model_maker/searcher/ExportFormat): An enumeration.

[`class ImageDataLoader`](../tflite_model_maker/searcher/ImageDataLoader): DataLoader class for Image Searcher Task.

[`class MetadataType`](../tflite_model_maker/searcher/MetadataType): An enumeration.

[`class ScaNNOptions`](../tflite_model_maker/searcher/ScaNNOptions): Options to build ScaNN.

[`class ScoreAH`](../tflite_model_maker/searcher/ScoreAH): Product Quantization (PQ) based in-partition scoring configuration.

[`class ScoreBruteForce`](../tflite_model_maker/searcher/ScoreBruteForce): Bruce force in-partition scoring configuration.

[`class Searcher`](../tflite_model_maker/searcher/Searcher): Creates the similarity search model with ScaNN.

[`class TextDataLoader`](../tflite_model_maker/searcher/TextDataLoader): DataLoader class for Text Searcher.

[`class Tree`](../tflite_model_maker/searcher/Tree): K-Means partitioning tree configuration.
