page_type: reference
description: Helper classes for common model metadata information.

<link rel="stylesheet" href="/site-assets/css/style.css">

<!-- DO NOT EDIT! Automatically generated file. -->


<div itemscope itemtype="http://developers.google.com/ReferenceObject">
<meta itemprop="name" content="tflite_support.metadata_writers.metadata_info" />
<meta itemprop="path" content="Stable" />
</div>

# Module: tflite_support.metadata_writers.metadata_info

<!-- Insert buttons and diff -->

<table class="tfo-notebook-buttons tfo-api nocontent" align="left">
<td>
  <a target="_blank" href="https://github.com/tensorflow/tflite-support/blob/v0.4.4/tensorflow_lite_support/metadata/python/metadata_writers/metadata_info.py">
    <img src="https://www.tensorflow.org/images/GitHub-Mark-32px.png" />
    View source on GitHub
  </a>
</td>
</table>



Helper classes for common model metadata information.

<section class="expandable">
  <h4 class="showalways">View aliases</h4>
  <p>
<b>Main aliases</b>
<p><a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.audio_classifier.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.audio_classifier.metadata_writer.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.bert_nl_classifier.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.bert_nl_classifier.metadata_writer.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.image_classifier.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.image_classifier.metadata_writer.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.image_segmenter.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.image_segmenter.metadata_writer.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.nl_classifier.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.nl_classifier.metadata_writer.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.object_detector.metadata_info</code></a>, <a href="https://www.tensorflow.org/lite/api_docs/python/tflite_support/metadata_writers/metadata_info"><code>tflite_support.metadata_writers.object_detector.metadata_writer.metadata_info</code></a></p>
</p>
</section>



## Modules

[`writer_utils`](../../tflite_support/metadata_writers/writer_utils) module: Helper methods for writing metadata into TFLite models.

## Classes

[`class AssociatedFileMd`](../../tflite_support/metadata_writers/metadata_info/AssociatedFileMd): A container for common associated file metadata information.

[`class BertInputTensorsMd`](../../tflite_support/metadata_writers/metadata_info/BertInputTensorsMd): A container for the input tensor metadata information of Bert models.

[`class BertTokenizerMd`](../../tflite_support/metadata_writers/metadata_info/BertTokenizerMd): A container for the Bert tokenizer [1] metadata information.

[`class CategoryTensorMd`](../../tflite_support/metadata_writers/metadata_info/CategoryTensorMd): A container for the category tensor metadata information.

[`class ClassificationTensorMd`](../../tflite_support/metadata_writers/metadata_info/ClassificationTensorMd): A container for the classification tensor metadata information.

[`class GeneralMd`](../../tflite_support/metadata_writers/metadata_info/GeneralMd): A container for common metadata information of a model.

[`class InputAudioTensorMd`](../../tflite_support/metadata_writers/metadata_info/InputAudioTensorMd): A container for the input audio tensor metadata information.

[`class InputImageTensorMd`](../../tflite_support/metadata_writers/metadata_info/InputImageTensorMd): A container for input image tensor metadata information.

[`class InputTextTensorMd`](../../tflite_support/metadata_writers/metadata_info/InputTextTensorMd): A container for the input text tensor metadata information.

[`class LabelFileMd`](../../tflite_support/metadata_writers/metadata_info/LabelFileMd): A container for label file metadata information.

[`class RegexTokenizerMd`](../../tflite_support/metadata_writers/metadata_info/RegexTokenizerMd): A container for the Regex tokenizer [1] metadata information.

[`class ScoreCalibrationMd`](../../tflite_support/metadata_writers/metadata_info/ScoreCalibrationMd): A container for score calibration [1] metadata information.

[`class SentencePieceTokenizerMd`](../../tflite_support/metadata_writers/metadata_info/SentencePieceTokenizerMd): A container for the sentence piece tokenizer [1] metadata information.

[`class TensorMd`](../../tflite_support/metadata_writers/metadata_info/TensorMd): A container for common tensor metadata information.
